// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
package JRunMC.ui;

import JRunMC.util.*;

// Imports
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.util.prefs.*;
import java.text.*;
import java.util.*;

class EditorInfo
 //     extends  JDialog 
 {

    private JButton jB1;
    private JButton jB2;


    private JComboBox jGroup;
    private JToggleButton jC1;
    private JToggleButton jC2;

    public static JTextField jTitle;
    public static JTextField jShortDescription;
    public static JTextField jAuthor;
    public static JTextField jContact;
    public static JTextField jLastModified;
    private static JScrollPane jScrollPane1; 
    private static JTextArea jDescription;
    private static String keepstring="";
    private JPopupMenu menu;
    private static final int rows=20; 
    private static final int columns=40;
    private static Preferences prefs;

    // text 
    private static String texjTitle="";
    private static String texjGroup="";
    private static String texjShortDescription="";
    private static String textjAuthor="";
    private static String textjContact="";
    private static String textjLastModified="";
    private static String textjDescription="";
    private static String[] array; 
    private static int oldindex=0;

    private JDialog editor;
    private HtmlBrowserDialog viewer;

 
        // Instance attributes used in this dialog
        public EditorInfo() {


         editor= new JDialog(); 
       //  super( Global.mainFrame );
          editor.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

         SetPref.prefs.put("version", "RunMC 4.0");



                // Set the frame characteristics
         editor.setTitle( "Info editor for "+SetIni.MOutput );
//         setSize( 420, 200 );

  JPanel topPanel = new JPanel();
  JPanel Panel0 = new JPanel();
  JPanel Panel1 = new JPanel();
  JPanel Panel2 = new JPanel();
  JPanel Panel3 = new JPanel();
  JPanel Panel4 = new JPanel();
  JPanel Panel5 = new JPanel();
  JPanel PanelX = new JPanel();

  JPanel lowerPanel = new JPanel();
  lowerPanel.setPreferredSize(new Dimension(600, 35));
  Panel0.setPreferredSize(new Dimension(600, 55)); 
  PanelX.setPreferredSize(new Dimension(180, 55));
  Panel1.setPreferredSize(new Dimension(600, 44));
  Panel2.setPreferredSize(new Dimension(600, 44));
  Panel3.setPreferredSize(new Dimension(600, 44));
  Panel4.setPreferredSize(new Dimension(600, 44));
  Panel5.setPreferredSize(new Dimension(600, 44));

        jB1 = new JButton();
        jB1.setText("Save");
        jB1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Save Settings?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) {   
                 try { 
                     getInfo();
                     SetPref.Write();
                     //  SetIni.ShowStatus="Last action: saving initial parameters";
                } catch (Exception e) {
                  System.out.println("Error when saving file..");
                  // show error
                  JOptionPane dialog = new JOptionPane();
                  dialog.showMessageDialog(dialog, "Cannot save!",
                  "Error", JOptionPane.ERROR_MESSAGE ); } 
           }
         }  });

 
        jB2 = new JButton();
        jB2.setText("Cancel");
        jB2.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Exit Editor?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) { 
     //      SetIni.ShowStatus="Last action: Exit Editor";  
           editor.setVisible(false); editor.dispose();}
        }  });


        
       lowerPanel.add(jB1, null);
       lowerPanel.add(jB2, null);
       editor.getContentPane().add( topPanel, java.awt.BorderLayout.CENTER );
       editor.getContentPane().add( lowerPanel, java.awt.BorderLayout.SOUTH );
 


       topPanel.setLayout(new BoxLayout(topPanel,BoxLayout.Y_AXIS));

       Panel0.setLayout( new BorderLayout() );
       PanelX.setLayout( new FlowLayout() );
       Panel1.setLayout( new BorderLayout() );
       Panel2.setLayout( new BorderLayout() );
       Panel3.setLayout( new BorderLayout() );
       Panel4.setLayout( new BorderLayout() );
       Panel5.setLayout( new BorderLayout() );

       topPanel.add(Panel0,null);

/*
       jGroup = new JComboBox();
        // Remove all items
       jGroup.removeAllItems();
       jGroup.setEditable(false);
*/

       array = (String[])SetEnv.ListGroup.toArray(new String[SetEnv.ListGroup.size()]);
       jGroup = new JComboBox(array);
       jGroup.setEditable(false);

/*
       // fill the combo 
    Iterator it = SetEnv.ListGroup.iterator();
    while (it.hasNext() ) {
       Object elem= it.next();
   //    jGroup.addItem( elem.toString() );
         jGroup.insertItemAt(elem.toString(), 0);
     }
    // jGroup.setSelectedIndex(0);
*/



       jGroup.setBorder(new TitledBorder(null,
                                    "Group",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION,
                                     new java.awt.Font("Dialog", 0, 12)));

     //  jGroup.setBounds(0,0,300,100);
       jGroup.setFont(SetEnv.FontBold);
       jGroup.setSelectedIndex(0);
       jGroup.setPreferredSize(new java.awt.Dimension(300, 54));
       Panel0.add(jGroup, BorderLayout.CENTER);



 // Create and register listener
    MyActionListener actionListener = new MyActionListener();
    jGroup.addActionListener(actionListener);


       Panel0.add(PanelX, BorderLayout.EAST);


       jC1 = new JToggleButton();
       jC1.setText("Add");
       jC1.setPreferredSize(new Dimension(80, 45));
        jC1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {


            jGroup.setEditable(true);
            jC1.setText("Freeze");
            // Add an item to the end of the list
           if (jC1.isSelected()) {
            jGroup.insertItemAt("", 0);
            jGroup.setSelectedIndex(0);  
           }

 
           if (!jC1.isSelected()) {

                  Object newItem = jGroup.getSelectedItem();
                  jGroup.removeItemAt(0);
                  jGroup.insertItemAt(newItem.toString(),0);

// remake  Set using new changes
                  SetEnv.ListGroup.clear();
                  for (int i=0; i<jGroup.getItemCount(); i++) {
                      String  s1 = jGroup.getItemAt(i).toString();
                      SetEnv.ListGroup.add(s1.trim());
                    }

// fill the combo, setin order  
                   Iterator it = SetEnv.ListGroup.iterator();
                   while (it.hasNext() ) {
                        Object elem= it.next();
                        jGroup.removeItemAt(0);
                        jGroup.insertItemAt(elem.toString(), 0);
                    }


                  jC1.setText("Add");
                  jGroup.setEditable(false);
                  jGroup.setSelectedIndex(0);
             }



/*
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Exit Editor?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) {
     //      SetIni.ShowStatus="Last action: Exit Editor";
            }
 
*/
       }  });


       jC2 = new JToggleButton();
        jC2.setText("Edit");
        jC2.setPreferredSize(new Dimension(80, 45));

        jC2.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
             jGroup.setEditable(true);

             jC2.setText("Freeze");
            if (!jC2.isSelected()) {

                  jC2.setText("Edit");
                // Remove first item
                 int num = jGroup.getItemCount();
                if (oldindex>-1 && oldindex<num) {
 
                  Object newItem = jGroup.getSelectedItem();
                  jGroup.removeItemAt( oldindex);
                  jGroup.insertItemAt(newItem.toString().trim(), oldindex);

// remake  Set using new changes 
                  SetEnv.ListGroup.clear();
                  for (int i=0; i<jGroup.getItemCount(); i++) {
                      String  s1 = jGroup.getItemAt(i).toString();
                      SetEnv.ListGroup.add(s1);
                    }

                   // System.out.println( SetEnv.ListGroup.size()  );
                  // fill the combo
                   Iterator it = SetEnv.ListGroup.iterator();
                   while (it.hasNext() ) {
                        Object elem= it.next();
                        jGroup.removeItemAt(0); 
                        jGroup.insertItemAt(elem.toString(), 0);
                    }

                 }
         //          jC2.setText("done"); 
         //       jGroup.insertItemAt(newItem.toString().trim(), 0);
                jGroup.setEditable(false);
         //    int nn  = jGroup.getSelectedIndex();
         //   System.out.println( oldindex );
          // now get all items




             }
        }  });

         PanelX.add(jC1,null);
         PanelX.add(jC2,null);






// new panel
       topPanel.add(Panel1,null);

       jTitle = new  JTextField();
       jTitle.setCaretColor(Color.red);  
      jTitle.setPreferredSize(new Dimension(350, 42));
//       jTitle.setMinimumSize(new java.awt.Dimension(200, 50));
//      jTitle.setMaximumSize(new java.awt.Dimension(600,40));
      jTitle.setBorder(new TitledBorder(null,
                                    "Title",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION,
                                     new java.awt.Font("Dialog", 0, 12)));
       jTitle.setEditable(true);
       Panel1.add(jTitle,BorderLayout.CENTER);
   

       jLastModified = new  JTextField();
       jLastModified.setCaretColor(Color.red);
       jLastModified.setPreferredSize(new Dimension(150, 42));
       jLastModified.setMinimumSize(new java.awt.Dimension(50, 42));
//       jLastModified.setMaximumSize(new java.awt.Dimension(100,40));
       jLastModified.setBorder(new TitledBorder(null,
                                    "Last modified",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION,
                                     new java.awt.Font("Dialog", 0, 12)));
       jLastModified.setEditable(true);
       Panel1.add(jLastModified,BorderLayout.EAST);


       topPanel.add(Panel2,BorderLayout.CENTER);
       jShortDescription = makeField("Short description");
       jShortDescription.setCaretColor(Color.red);  
       Panel2.add(jShortDescription,null);
     
       topPanel.add(Panel3,BorderLayout.CENTER); 
       jAuthor = makeField("Author(s)");
       jAuthor.setCaretColor(Color.red); 
        Panel3.add(jAuthor,null);


       topPanel.add(Panel4,BorderLayout.CENTER);
       jContact = makeField("Contact");
       jContact.setCaretColor(Color.red); 
        Panel4.add(jContact,null);

       topPanel.add(Panel5,BorderLayout.CENTER);
//       jLastModified = makeField("Last modified");
//       Panel5.add(jLastModified,null);


 // comments
         jScrollPane1 = new JScrollPane();
         jDescription = new JTextArea(rows, columns);
         jScrollPane1.getViewport().add( jDescription );

         jDescription.setLineWrap(true); 
         jDescription.setWrapStyleWord(true);
         jDescription.setCaretColor(Color.red);


       // pop-up menu for table
    menu = new JPopupMenu();
    JMenuItem icut = new JMenuItem("Cut");
    JMenuItem icopy = new JMenuItem("Copy");
    JMenuItem ipaste = new JMenuItem("Paste");
    menu.add(icut);
    menu.add(icopy);
    menu.add(ipaste);

// Set the component to show the popup menu
    jDescription.addMouseListener(new MouseAdapter() {
        public void mousePressed(MouseEvent evt) {
            if (evt.isPopupTrigger()) {
                menu.show(evt.getComponent(), evt.getX(), evt.getY());
            }
        }
        public void mouseReleased(MouseEvent evt) {
            if (evt.isPopupTrigger()) {
                menu.show(evt.getComponent(), evt.getX(), evt.getY());
            }
        }
    });


// cut
    icut.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
                // Get text inside selection
            // String s=jDescription.getSelectedText();
            // Replace selected text
            jDescription.replaceSelection("");

         //   System.out.println(s);
            jScrollPane1.revalidate();
            jScrollPane1.repaint();
     }  });


// icopy
    icopy.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
                // Get text inside selection
            keepstring=jDescription.getSelectedText();
             int nn = jDescription.getSelectionStart();
             jDescription.select(nn, nn); // clear selection 

     }  });

// ipaste
    ipaste.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
                // Get text inside selection
          int pos=jDescription.getCaretPosition();

        if (pos <= jDescription.getDocument().getLength()) {
            jDescription.insert(keepstring, pos);
            keepstring="";
          // jDescription.clearSelection();
        }
     }  });





 
         jDescription.setBorder(new TitledBorder(null,
                                   "Description",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION,
                                     new java.awt.Font("Dialog", 0, 12)));


         jDescription.setFont(SetEnv.FontBold);
         jDescription.setEditable(true);
         topPanel.add(jScrollPane1,null);


 
//         Show();
// pack();

// read preferences and set
        readInfo();



        }   


private static JTextField makeField(String token)
   {

      JTextField item;
      item = new  JTextField( columns );
//      item.setPreferredSize(new Dimension(400, 40));
//      item.setMinimumSize(new java.awt.Dimension(50, 40));
      item.setMaximumSize(new java.awt.Dimension(600,42));
      item.setBorder(new TitledBorder(null,
                                    token,TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION,
                                     new java.awt.Font("Dialog", 0, 12)));
      item.setEditable(true);
      return item;
   }
          
      


// create about
   public void readInfo() {


   // read preferences from the file (again!)
   SetPref.Read();


  texjTitle =  SetPref.prefs.get(SetPref.keyjTitle,""); 
  jTitle.setText(texjTitle);


   texjGroup =  SetPref.prefs.get(SetPref.keyjGroup,"");
   int iset=-1; 
   for (int i=0; i<jGroup.getItemCount(); i++) {
                      String  s1 = jGroup.getItemAt(i).toString();
                      if (texjGroup.equals(s1.trim()) )iset=i;
                    }
    if (iset>-1) jGroup.setSelectedIndex(iset);


//  int nn= Utility.GetInt( texjGroup );
//  jGroup.setSelectedIndex( nn );


  texjShortDescription = SetPref.prefs.get(SetPref.keyjShortDescription, "");
  jShortDescription.setText( texjShortDescription );

  textjAuthor = SetPref.prefs.get(SetPref.keyjAuthor, "");
  jAuthor.setText(textjAuthor);


  textjContact = SetPref.prefs.get(SetPref.keyjContact, "");
  jContact.setText(textjContact);

  textjLastModified = SetPref.prefs.get(SetPref.keyjLastModified, "");
  jLastModified.setText(textjLastModified);

  textjDescription= SetPref.prefs.get(SetPref.keyjDescription, "");
  jDescription.setText(textjDescription);


}



// create about
   public void getInfo() {


        SetPref.prefs.put(SetPref.keyProject, new String( SetIni.MOutput )  );

         // Get today's date
       Date date = new Date();
       Format  formatter = new SimpleDateFormat("dd-MMM-yy");
       SetPref.prefs.put(SetPref.keyTime, new String( formatter.format(date) )  ); 


        texjTitle=jTitle.getText();
//        System.out.println( texjTitle );      
        SetPref.prefs.put(SetPref.keyjTitle, new String( texjTitle )  );

//
        texjGroup  = jGroup.getSelectedItem().toString(); 
        SetPref.prefs.put(SetPref.keyjGroup, new String( texjGroup )  );

 
        texjShortDescription=jShortDescription.getText();
//        System.out.println( texjShortDescription );
        SetPref.prefs.put(SetPref.keyjShortDescription, new String( texjShortDescription  )  );

        textjAuthor=jAuthor.getText();
//        System.out.println( textjAuthor );
        SetPref.prefs.put(SetPref.keyjAuthor, new String( textjAuthor  )  );

        textjContact=jContact.getText();
//        System.out.println( textjContact );
        SetPref.prefs.put(SetPref.keyjContact, new String( textjContact  )  );

        textjLastModified=jLastModified.getText();
//        System.out.println( textjLastModified  );
        SetPref.prefs.put(SetPref.keyjLastModified, new String( textjLastModified  )  );

        textjDescription=jDescription.getText();
//        System.out.println( textjDescription  );
        SetPref.prefs.put(SetPref.keyjDescription, new String( textjDescription  )  );

 

    }




 

// create about
   public void Show() {

// store mainframe dimensions
    Dimension dim = Global.mainFrame.getSize();
    int w=dim.width;
    int h=dim.height;
 // Get the system resolution
    Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
    Dimension size = new Dimension(Math.min( (int)(1.1*w),res.width),
                        Math.min((int)(1.0*h), res.height) );
    editor.setSize(size);
    Util.rightWithin ( Global.mainFrame, editor );

//    Util.centreWithin( Global.mainFrame, this );
    editor.setVisible(true);

   }



 // Instance attributes used in this dialog
    public void ShowHTML() {


   String hstr = ResourceLoader.getDisplay( "dlg.rmcviewer" );
   viewer = new HtmlBrowserDialog( Global.mainFrame, hstr, true );

   String HEARD="<html> <body> \n"; 
   String TITLE1="<h2><font color=#000099>"+SetPref.prefs.get(SetPref.keyjTitle,"")+"</font></h2>\n"; 
   // show group
   texjGroup= SetPref.prefs.get(SetPref.keyjGroup,""); 
   String TITLE2 = "<b> Project group: "+texjGroup+"</b><p>\n"; 
   String STITLE="<b>"+SetPref.prefs.get(SetPref.keyjShortDescription,"")+"</b><br>\n";
   String A="<b>"+SetPref.prefs.get(SetPref.keyjAuthor,"")+"</b><br>\n";
   String C="<b>"+SetPref.prefs.get(SetPref.keyjContact,"")+"</b><br>\n";
   String L="<b><i>"+SetPref.prefs.get(SetPref.keyjLastModified,"")+"</i></b> <p>  \n";
   String D="<b>"+SetPref.prefs.get(SetPref.keyjDescription,"")+"</b>\n";

   String END = "</body> </html>"; 

   viewer.setText( HEARD+TITLE1+TITLE2+STITLE+A+C+L+D+END); 

    Dimension dim = Global.mainFrame.getSize();
    int w=dim.width;
    int h=dim.height;
 // Get the system resolution
    Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
    Dimension size = new Dimension(Math.min( (int)(0.9*w),res.width),
                        Math.min((int)(1.1*h), res.height) );
    viewer.setSize(size);
    Util.rightWithin ( Global.mainFrame, viewer );

    viewer.setCaretStart();
    viewer.setVisible(true);

   }


 
 class MyActionListener implements ActionListener {
        // Retain the previously selected item in order to determine whether
        // the new item is the same
        Object oldItem;
    
        // This method is called whenever the user or program changes the selected item.
        // Note: The new item may be the same as the previous item.
        public void actionPerformed(ActionEvent evt) {
            JComboBox cb = (JComboBox)evt.getSource();
    
            // Get the new item
            Object newItem = cb.getSelectedItem();
            int nn  = cb.getSelectedIndex();
            if (nn>-1) oldindex=nn;

    //        System.out.println( nn );
 
            // Determine if different from previously selected item
            boolean same = newItem.equals(oldItem);
            oldItem = newItem;
    
            if ("comboBoxEdited".equals(evt.getActionCommand())) {
                // User has typed in a string; only possible with an editable combobox
//                 System.out.println( "new="+newItem.toString()  );
//                 System.out.println( "old="+oldItem.toString()  );
 
       //              jGroup.setSelectedItem(newItem.toString());                 
                      
                   // Remove all items
                  //jGroup.removeAllItems();
//                  SetEnv.ListGroup.add(newItem.toString());
                  
//                 array[nn]=newItem.toString();
                   // sort again 
//                   SetEnv.ListGroup.clear();

//                    for (int i=0; i<array.length; i++) {
//                          SetEnv.ListGroup.add(array[i].trim());
//                     }
 
//         String [] array2 = (
//        String[])SetEnv.ListGroup.toArray(new String[SetEnv.ListGroup.size()]);


         //   array[nn]=newItem.toString();
//         jGroup.removeAllItems();
//         for (int i=0; i<array2.length; i++) jGroup.insertItemAt(array2[i], 0); 


            } else if ("comboBoxChanged".equals(evt.getActionCommand())) {
                // User has selected an item; it may be the same item

//                 System.out.println( "-new="+newItem.toString()  );
//                 System.out.println( "-old="+oldItem.toString()  );
            }
        }

 }


} // end class

