
package JRunMC.ui;

// Imports
import java.awt.*;
import java.awt.datatransfer.*; 
import java.awt.dnd.*;
import java.awt.event.*;
import javax.swing.*;



public class JTableSource extends JTable
        implements DragGestureListener, DragSourceListener {

        DragSource dragSource;
         public static final long serialVersionUID = 5;

    
        public JTableSource() {
            dragSource = new DragSource();
            dragSource.createDefaultDragGestureRecognizer(
                this, DnDConstants.ACTION_COPY_OR_MOVE, this);
        }
        public void dragGestureRecognized(DragGestureEvent evt) {

            int selected=getSelectedRow();
            Object obb1=getValueAt(selected, 0);
            Object obb2=getValueAt(selected, 1); 
            Transferable t = new StringSelection( obb1.toString()+ " " + obb2.toString() );
            dragSource.startDrag (evt, DragSource.DefaultCopyDrop, t, this);
        }
        public void dragEnter(DragSourceDragEvent evt) {
            // Called when the user is dragging this drag source and enters
            // the drop target.

        }
        public void dragOver(DragSourceDragEvent evt) {
           // Called when the user is dragging this drag source and moves
          // over the drop target.
          //   int selected=getSelectedRow();
          //   System.out.println(selected);

        }
        public void dragExit(DragSourceEvent evt) {
            // Called when the user is dragging this drag source and leaves
            // the drop target.
        }
        public void dropActionChanged(DragSourceDragEvent evt) {
            // Called when the user changes the drag action between copy or move.
        }
        public void dragDropEnd(DragSourceDropEvent evt) {
         // Called when the user finishes or cancels the drag operation.
           int selected=getSelectedRow();
         //   System.out.println(selected);
            clearSelection();
        }
    }
