// * This code is licensed under:
// * RunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de).
// * All rights reserved.


#include <TROOT.h>
#include "CLHEP/config/CLHEP.h"
#include "CLHEP/config/iostream.h"
#include "CLHEP/config/iomanip.h"
#include "CLHEP/HepPDT/ParticleID.hh"
using namespace std;

Int_t charge3(Int_t id) {
// get 3-charge 

//    int it,sid,js,ls;
    int  nr, nx;
    int chg, extra;

       HepPDT::ParticleID pid( id );
        nx = pid.digit(HepPDT::n);
        nr = pid.digit(HepPDT::nr);
        extra = pid.extraBits();
//        cout << endl;
//        cout << setw(18) << id << ": " << nx << " " << nr
//                     << " " << pid.digit(HepPDT::nl)
//                     << " " << pid.digit(HepPDT::nq1) << " "
//                     << pid.digit(HepPDT::nq2) << " " << pid.digit(HepPDT::nq3)
//                     << " " <<  pid.digit(HepPDT::nj)
//                     << " extra bits " << extra << endl;


//        js = pid.jSpin();
//        HepPDT::Quarks cqks = pid.quarks( );
//        ls = pid.lSpin();
//        sid = pid.fundamentalID();
 
       chg = (Int_t)pid.threeCharge();

//        cout << setw(18) << id << " 3 charge "  << chg <<  endl;
 

        return chg;

   }
