package com.jpe;

// Defines application wide constants

import  com.utils.*;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import java.awt.Dimension;
import java.awt.Font;
import java.net.*;

public interface Constants {

  final static String fileSep = System.getProperty("file.separator");

  String nums[] = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15"};

  String getprops[] = {"jpe.recents0", "jpe.recents1", "jpe.recents2", "jpe.recents3", "jpe.recents4",
                   "jpe.recents5", "jpe.recents6", "jpe.recents7", "jpe.recents8", "jpe.recents9",
                   "jpe.recents10", "jpe.recents11", "jpe.recents12", "jpe.recents13", "jpe.recents14"};

  final static String javaApp = new String("Docs" + fileSep + "Untitled.java");
	final static String javaApplet = new String("Docs" + fileSep + "Untitled1.java");

	final static String VER_NO = new String("0.9");

	final static int TOOL_BAR_WIDTH = 570;

	final static String SYSTEM_ERROR = new String("An application error has occured, please see error log. Tools > Error log");

	final static Font   SYSTEM_FONT = new Font("Arial", Font.BOLD, 12);

        final static String License = ResourceLoader.getCommand( "html.license" );
        final static URL UrlLicense = ResourceLoader.getResourceURL( "#standards/" + License );

        final static String Readme = ResourceLoader.getCommand( "html.about" );
        final static URL UrlReadme = ResourceLoader.getResourceURL( "#standards/" +  Readme );

	final static String ErrorLog = new String("Docs" + fileSep + "errorlog" + fileSep + "errorlog.txt");

	final static String newline = "\n";

	final static int a = 0;

	final static Icon pcIcon        = ResourceLoader.getImageIcon("mypc");
	final static Icon driveIcon     = ResourceLoader.getImageIcon("drive");
	final static Icon blankIcon     = ResourceLoader.getImageIcon("tree-leaf");
	final static Icon saveIcon      = ResourceLoader.getImageIcon("tree-leaf-mixed");
  final static Icon dirtyIcon     = ResourceLoader.getImageIcon("tree-leaf-script");

  final static Icon leafIcon      = ResourceLoader.getImageIcon("tree-leaf");
  final static Icon expandedIcon  = ResourceLoader.getImageIcon("expanded");
  final static Icon collapsedIcon = ResourceLoader.getImageIcon("collapsed");
  final static Icon openIcon      = ResourceLoader.getImageIcon("tree-open");
  final static Icon closedIcon    = ResourceLoader.getImageIcon("tree-closed");

  final static Icon bmadd         = ResourceLoader.getImageIcon("addbm");
  final static Icon bmrem         = ResourceLoader.getImageIcon("rembm");
//final static Icon bmnext      = new ImageIcon("images" + fileSep + "nextbm.gif");
//final static Icon bmprev      = new ImageIcon("images" + fileSep + "prevbm.gif");

	final static Icon clip          = ResourceLoader.getImageIcon("clip");
	final static Icon clipsys       = ResourceLoader.getImageIcon("clipsys");
	final static Icon spacer        = ResourceLoader.getImageIcon("spacer");

  final static Icon DelLine       = ResourceLoader.getImageIcon("Remove16");
  final static Icon UndO          = ResourceLoader.getImageIcon("Undo16");
	final static Icon RedO          = ResourceLoader.getImageIcon("Redo16");
	final static Icon SearcH        = ResourceLoader.getImageIcon("Find16");
	final static Icon Searcnext     = ResourceLoader.getImageIcon("FindAgain16");
	final static Icon ReplacE       = ResourceLoader.getImageIcon("Replace16");
	final static Icon zipas         = ResourceLoader.getImageIcon("zipsub");
	final static Icon OpeN          = ResourceLoader.getImageIcon("Open16");
	final static Icon ClosE         = ResourceLoader.getImageIcon("Close16");
	final static Icon PrinT         = ResourceLoader.getImageIcon("Print16");
	final static Icon PrintpreV     = ResourceLoader.getImageIcon("PrintPreview16");
	final static Icon SavE          = ResourceLoader.getImageIcon("Save16");
	final static Icon SaveaS        = ResourceLoader.getImageIcon("SaveAs16");
	final static Icon CuT           = ResourceLoader.getImageIcon("Cut16");
	final static Icon CopY          = ResourceLoader.getImageIcon("Copy16");
	final static Icon PastE         = ResourceLoader.getImageIcon("Paste16");
	final static Icon DeL           = ResourceLoader.getImageIcon("Delete16");
	final static Icon DukE          = ResourceLoader.getImageIcon("duke");
	final static Icon runjava       = ResourceLoader.getImageIcon("runjava");
	final static Icon javac         = ResourceLoader.getImageIcon("javac");
        final static Icon runroot       = ResourceLoader.getImageIcon("runroot");
        final static Icon runpython     = ResourceLoader.getImageIcon("runpython");
	final static Icon saveAllsub    = ResourceLoader.getImageIcon("SaveAll16");
	final static Icon closeAllsub   = ResourceLoader.getImageIcon("CloseAll16");


	//define button images
	final static Icon New       = ResourceLoader.getImageIcon("New16");
	final static Icon DelSub    = ResourceLoader.getImageIcon("delSub");
	final static Icon Open      = ResourceLoader.getImageIcon("Open16");
	final static Icon Save      = ResourceLoader.getImageIcon("Save16");
	final static Icon SaveAs    = ResourceLoader.getImageIcon("SaveAs16");
	final static Icon Undo      = ResourceLoader.getImageIcon("Undo16");
	final static Icon RedoAll   = ResourceLoader.getImageIcon("Redo16");
	final static Icon UndoAll   = ResourceLoader.getImageIcon("Undo16");
	final static Icon Redo      = ResourceLoader.getImageIcon("Redo16");
	final static Icon Print     = ResourceLoader.getImageIcon("Print16");
	final static Icon PrintPrev = ResourceLoader.getImageIcon("PrintPreview16");
	final static Icon Close     = ResourceLoader.getImageIcon("Close16");
	final static Icon Copy      = ResourceLoader.getImageIcon("Copy16");
	final static Icon Cut       = ResourceLoader.getImageIcon("Cut16");
	final static Icon Paste     = ResourceLoader.getImageIcon("Paste16");
	final static Icon Del       = ResourceLoader.getImageIcon("Delete16");
//	final static Icon FontTool  = ResourceLoader.getImageIcon("fontool");
	final static Icon Search    = ResourceLoader.getImageIcon("Search16");
	final static Icon Replace   = ResourceLoader.getImageIcon("Replace16");
	final static Icon ZipAs     = ResourceLoader.getImageIcon("zip");
	final static Icon MakeRMC   = ResourceLoader.getImageIcon("handtool");
	final static Icon flocked   = ResourceLoader.getImageIcon("locked");
	final static Icon funlocked = ResourceLoader.getImageIcon("unlocked");


	//Icon clip2     = new ImageIcon("images" + fileSep + "clip.gif");
	//Icon clip3     = new ImageIcon("images" + fileSep + "clip.gif");

	final static Icon projwin     = ResourceLoader.getImageIcon("projwin");
	final static Icon clock       = ResourceLoader.getImageIcon("clock");
	final static Icon clockdis    = ResourceLoader.getImageIcon("clockdis");
//	final static Icon tool        = ResourceLoader.getImageIcon("tool");
	final static Icon Refresh     = ResourceLoader.getImageIcon("Refresh16");
	final static Icon saveAll     = ResourceLoader.getImageIcon("Saveall16");
	final static Icon closeAll    = ResourceLoader.getImageIcon("CloseAll16");
	final static Icon closeCross  = ResourceLoader.getImageIcon("closecross");

	//create some spacers using dimension object
	final static Dimension d = new Dimension(1, 0);
	final static Dimension r = new Dimension(8, 0);
	final static Dimension e = new Dimension(10, 0);

//initial values



}
