// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
// define your enviromental variable
package JRunMC.ui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.lang.*;



   public class  SetEnv {
     

// localisation
     public static Locale   locale;
     public static String   LANGU;

// file with the settings 
      public static String INIFILE="";

  // location of GUI
     public static  int  gui_x;
     public static  int  gui_y;
     public static  int  gui_h;
     public static  int  gui_w;
     public static  String OSsys;


// HTML styles
    public static String font_family="Lucida Sans";
    public static String font_name="Lucida Sans Demibold";
    public static String font_size="14";
    public static String font_face="bold";
    public static String font_style="normal";
    public static String background_color="#FFFFFC";
    public static String color="#000000";

// to allow Run 
    public static boolean RunAllow;   
    public static boolean ReadMCdone;

    public static TreeSet<String> ListGroup;
 
// which tab is active? 
    public static int TabActive=0;

     public static String RUNDIR="not set";      // current directory
     public static String RUNDIRwin32="not set"; // for windows
     public static String ROOTSYS="not set"; // ROOT
     public static final String WEBFILES="archive_web"; // location of web files 

     public static String defa= "Default";
     
     public static String metal= "Metal";
     public static String metalClassName = "javax.swing.plaf.metal.MetalLookAndFeel";

     public static String motif = "Motif";
     public static String motifClassName =
            "com.sun.java.swing.plaf.motif.MotifLookAndFeel";

     public static String windows = "Windows";
     public static String windowsClassName =
            "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
   
     public static String liquid = "Liquid";
     public static String liquidClassName =
            "com.birosoft.liquid.LiquidLookAndFeel";

     public static String kunststoff = "Kunststoff";
     public static String kunststoffClassName =
            "com.incors.plaf.kunststoff.KunststoffLookAndFeel";

 
     public static int Style=0; // select style
     public static Font FontBold;
     public static Font FontPlain;    
     
       
     

    public static void init() { 


     RunAllow=true;
     ReadMCdone=false;

// send default local
     LANGU="en";
     locale = new Locale(LANGU);
     Locale.setDefault(locale);

     String OS = System.getProperty("os.name").toLowerCase();

  if (OS.indexOf("windows") > -1 || OS.indexOf("nt") > -1) {
     OSsys="windows";
     INIFILE="jrunmc.ini";
  }  else {
     // linux/unix/BS-based/mac
     OSsys="linux";
     INIFILE=".jrunmcrc";
    }

//     System.out.println(OSsys);
 
     FontBold= new Font("Lucida Sans", Font.BOLD, 14); 
     FontPlain= new Font("Lucida Sans", 0, 14);


     ListGroup = new TreeSet<String>();
     ListGroup.add("All categories");

/*
    String newline;
    newline = System.getProperty("user.dir");
   // System.out.println(newline);
    newline = System.getProperty("user.home");
  //  System.out.println(newline);
    newline = System.getProperty("os.arch");
  //  System.out.println(newline);
    newline = System.getProperty("os.name");
  //  System.out.println(newline);
    newline = System.getProperty("java.vm.version");
  //  System.out.println(newline);
    newline = System.getProperty("java.vm.name");
  //  System.out.println(newline);

 */
 
    // get $RUNMC variable, works for all  Java versions 
    try {
    String sh = "bash"; String cop = "-c";              
    String cmd1 = "echo $RUNMC";
    String[] exe1 = new String[] {sh, cop, cmd1};
    Process p = Runtime.getRuntime().exec(exe1);

    PrintWriter out = new PrintWriter(new BufferedWriter(
    new OutputStreamWriter(p.getOutputStream())));
    out.println("exit");
    out.flush();
    BufferedReader inp = new BufferedReader(
    new InputStreamReader(p.getInputStream()));
    // retrieve data from standard output stream
    String line = inp.readLine();
    if (line.length()>1) RUNDIR=line;
/*
    while ((line = inp.readLine()) != null ) {
    if (line.length()>1) RUNDIR=line;
    }
*/
    inp.close();
    } catch (Exception err) {
     err.printStackTrace();
     };


     if ( OSsys.equals("windows") ) { 
    // get $RUNMC variable, works for all  Java versions 
    try {
    String sh = "bash"; String cop = "-c";     
    String cmd1 = "cygpath -da $RUNMC";
    String[] exe1 = new String[] {sh, cop, cmd1};
    Process p = Runtime.getRuntime().exec(exe1);
    PrintWriter out = new PrintWriter(new BufferedWriter(
    new OutputStreamWriter(p.getOutputStream())));
    out.println("exit");
    out.flush();
    BufferedReader inp = new BufferedReader(
    new InputStreamReader(p.getInputStream()));
    // retrieve data from standard output stream
    String line = inp.readLine();
    if (line.length()>1) RUNDIRwin32=line;
/*
    while ((line = inp.readLine()) != null ) {
    if (line.length()>1) RUNDIR=line;
    }
*/
    inp.close();
    } catch (Exception err) {
     err.printStackTrace();
     };
    }
 
// ROOT
    try {
    String sh = "bash"; String cop = "-c";
    String cmd1 = "echo $ROOTSYS";
    String[] exe1 = new String[] {sh, cop, cmd1};
    Process p = Runtime.getRuntime().exec(exe1);
    PrintWriter outw = new PrintWriter(new BufferedWriter(
    new OutputStreamWriter(p.getOutputStream())));
    outw.println("exit");
    outw.flush();
    BufferedReader inp = new BufferedReader(
    new InputStreamReader(p.getInputStream()));
    String line = inp.readLine(); 
    if (line.length()>1)  ROOTSYS=line;
    inp.close();
//    while ((line = inp.readLine()) != null)
//     if (line.length()>1) ROOTSYS=line;
    } catch (Exception err) {
     err.printStackTrace();
     }   
    
     
//    System.out.println(RUNDIR);
//    System.out.println(RUNDIRwin32);
//    System.out.println(ROOTSYS);
     

    
     } 
    
    
    
     
     
   }
