CDECK  ID>, HWPHTT.
*CMZ :-        -11/08/03  15:30:25  by  Peter Richardson
*-- Author :    Peter Richardson and Zbigniew Was 
C-----------------------------------------------------------------------
      SUBROUTINE HWPHTT
C-----------------------------------------------------------------------
C     subroutine for radiation in top production
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
C--local variables
      INTEGER IMO(10),IFOUND,JMO(2),I,J,K,L,NSTART,NHEPX,NHEP0
C--initialisation
      IF(IERROR.NE.0) RETURN
      IFOUND=0
      DO K=1,10
        IMO(K)=0
      ENDDO
C--loop to find mothers of any tops
      NSTART=1
      DO I=NSTART,NHEP
        IF (ABS(IDHEP(I)).EQ.6) THEN
          DO K=1,IFOUND
           IF(IMO(K).EQ.JMOHEP(1,I)) GOTO 10
          ENDDO
          IFOUND=IFOUND+1
          IMO(IFOUND)=JMOHEP(1,I)
        ENDIF
 10     CONTINUE
      ENDDO
C--generate the radiation
      DO K=1,IFOUND
C--save the colour mother pointers
        JMO(1)=JMOHEP(2,JDAHEP(1,IMO(K)))
        JMO(2)=JMOHEP(2,1+JDAHEP(1,IMO(K)))
C--zero the second mothers
        NHEP0=NHEP
        JMOHEP(2,JDAHEP(1,IMO(K)))=0
        JMOHEP(2,JDAHEP(2,IMO(K)))=0
C--call photos to generate radiation
        CALL PHOTOS(IMO(K))
        NHEPX=NHEP
        DO 11 J=NHEP,1,-1
          IF(IDHEP(J).EQ.22) THEN
            NHEPX=NHEPX-1
          ELSE
            GOTO 11
          ENDIF
 11     CONTINUE
C--reset the colour pointers
        JMOHEP(2,  JDAHEP(1,IMO(K)))=JMO(1)
        JMOHEP(2,1+JDAHEP(1,IMO(K)))=JMO(2)
C--setup the photons
        DO L=NHEPX+1,NHEP
          ISTHEP(L)=114
          JMOHEP(2,L) = L
          JDAHEP(2,L) = L
          IDHW(L) = 59
        ENDDO
      ENDDO 
      END
