CDECK  ID>, HWUMBW.
*CMZ :-        -21/02/98  11.11.56  by  Bryan Webber
*-- Author :    Bryan Webber
C-----------------------------------------------------------------------
      FUNCTION HWUMBW(ID)
C-----------------------------------------------------------------------
C     CHOOSES MASS ACCORDING TO BREIT-WIGNER DISTRIBUTION
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION HWUMBW,HWRGEN,WMX,TAU,T
      INTEGER ID
C--WMX IS MAX NUMBER OF WIDTHS FROM NOMINAL MASS
      DATA WMX/10D0/
      SAVE WMX
      HWUMBW=RMASS(ID)
      IF(ID.EQ.198.OR.ID.EQ.199) THEN
        TAU = HBAR/GAMW
      ELSEIF(ID.EQ.200) THEN
        TAU = HBAR/GAMZ
      ELSE
        TAU=RLTIM(ID)
      ENDIF
      IF (TAU.EQ.ZERO.OR.TAU.GT.1D-18) RETURN
 1    T=HALF*TAN(PIFAC*(HWRGEN(0)-HALF))
      IF (ABS(T).GT.WMX) GO TO 1
      HWUMBW=RMASS(ID)+HBAR*T/TAU
      IF(HWUMBW.LT.ZERO) GOTO 1
      END
