CDECK  ID>, HWUMPO.
*CMZ :-        -26/11/00  17.21.55  by  Bryan Webber
*-- Author :  Kosuke Odagiri
C-----------------------------------------------------------------------
      SUBROUTINE HWUMPO(P,M,PMM,MGAM,PPROJ,FPROP)
C-----------------------------------------------------------------------
C     RETURNS PROJECTION OPERATOR 1/(P-SLASH - M + I*MGAM) IN WEYL-BASIS
C     USED IN SUBROUTINE HWH2QH
C-----------------------------------------------------------------------
      DOUBLE PRECISION P(0:3),M,PMM,MGAM,ZERO,ONE
      DOUBLE COMPLEX PROP, PPROJ(4,4), CZERO
      LOGICAL FPROP
      PARAMETER (ZERO=0.D0,CZERO=(0.D0,0.D0),ONE=1.D0)
      IF (FPROP) THEN
       PROP=ONE/DCMPLX(PMM,MGAM)
      ELSE
       PROP=DCMPLX(ONE/PMM, ZERO)
      END IF
      PPROJ(1,1) =  M*PROP
      PPROJ(1,2) =  CZERO
      PPROJ(2,1) =  CZERO
      PPROJ(2,2) =  PPROJ(1,1)
      PPROJ(1,3) = (P(0)-P(3))*PROP
      PPROJ(1,4) =  DCMPLX(-P(1),P(2))*PROP
      PPROJ(2,3) =  DCMPLX(-P(1),-P(2))*PROP
      PPROJ(2,4) = (P(0)+P(3))*PROP
      PPROJ(3,1) =  PPROJ(2,4)
      PPROJ(3,2) = -PPROJ(1,4)
      PPROJ(4,1) = -PPROJ(2,3)
      PPROJ(4,2) =  PPROJ(1,3)
      PPROJ(3,3) =  PPROJ(1,1)
      PPROJ(3,4) =  CZERO
      PPROJ(4,3) =  CZERO
      PPROJ(4,4) =  PPROJ(1,1)
      RETURN
      END
