
       SUBROUTINE runmcarlo(IRUN, ierr)

C next one - not common! for initialisation
      DOUBLE PRECISION P1(4),P2(4)
      INTEGER ICARD
      SAVE  P1,P2, ICARD 
      DOUBLE PRECISION  SIGCUR,  SIGMAX
      SAVE SIGCUR,  SIGMAX
      INTEGER NN1,NN2,NN3,NN4
      CHARACTER *12 inputsteer

      LOGICAL  EX0,EX,EX1
      INTEGER IOSTA
      SAVE IOSTA

      include "../mcarlo/inc/phojet.inc"
C      include "../mcarlo/inc/jetset74-phojet.inc"
      include "../mcarlo/inc/jetset74.inc"
      include "../inc/hepevt_pythia57.inc"
      include "../inc/getevkin.inc"
      include "../inc/getseeds.inc"

 
C from C++ interface 
C      IRUN=1 - initialize
C      IRUN=2 - run
C      IRUN=3 - terminate
C      ierr- no errors, event accepted 
C      written by S.Chekanov, May, 2003

C
      Integer I, J, N, nev
      Integer IRUN,ierr,IREJ,IPAR
      Save nev 

      goto (1000, 2000, 3000) IRUN
      return

*      IF (IRUN.eq.0) GOTO 100
*      IF (IRUN.eq.1) GOTO 200
*      IF (IRUN.eq.2) GOTO 300

 1000   CONTINUE 


       write(6,*)'initialisation of PHOJET 1.1 by RUNMC '
       CALL LUGIVE('PARJ(72)=1000') ! mm maximum distance from the origin at
                     ! a decay is allowed to take place
       CALL LUGIVE('MSTJ(22)=3')  ! particle is decayed only if the decay vertex is
                     ! within a distance PARJ(72) of the origin
      write(6,*)PARJ(72),'mm maximum distance a decay is allowed'

C set seed number
      MRLU(1)=RUNMCseed1+RUNMCseed2
C      write(6,*) " RunMC : PHOJETs new seed for this run = ",MRLU(1)
      write(6,*) " RunMC : PID1=",PID1, " Energy1=",ENER1
      write(6,*) " RunMC : PID2=",PID2, " Energy2=",ENER2


C taken forPJOJET 
C      CALL PORNIN(RUNMCseed1,RUNMCseed2,INT(RUNMCseed1+1),MRLU(1))

*-take positron (default) 
       nev=0
       ierr=1
       xCross=0.
       eCross=0.

C        IF (PDF1.eq.1.or.PDF2.eq.1)  LST(15)=4046 ! CTEQ5 LO 
C        IF (PDF1.eq.2.or.PDF2.eq.2)  LST(15)=3072 ! MRST c-g LO
C        IF (PDF1.eq.3.or.PDF2.eq.3)  LST(15)=5012 ! GRV 98 LO
C sets PDFs
C this should be under the control of 

C  general initialization of phojet data structures
C  Fixing seeds 
      NN1=12
      NN2=34
      NN3=56
      NN4=78
      IF (RUNMCseed1.lt.168)  NN1=RUNMCseed1 
      IF (RUNMCseed1.gt.168)  NN1=INT(0.1*RUNMCseed1) 
      IF (RUNMCseed1.gt.1680) NN1=INT(0.01*RUNMCseed1) 
      IF (RUNMCseed1.gt.16800) NN1=INT(0.001*RUNMCseed1)
      IF (RUNMCseed1.gt.168000) NN1=INT(0.0001*RUNMCseed1)
      IF (RUNMCseed1.gt.1680000) NN1=INT(0.00001*RUNMCseed1)
      IF (NN1.le.1)  NN1=12
      IF (RUNMCseed2.lt.168) NN2=RUNMCseed2
      IF (RUNMCseed2.gt.168) NN2=INT(0.1*RUNMCseed2)
      IF (RUNMCseed2.gt.1680) NN2=INT(0.01*RUNMCseed2)
      IF (RUNMCseed2.gt.16800) NN2=INT(0.001*RUNMCseed2)
      IF (RUNMCseed2.gt.168000) NN2=INT(0.0001*RUNMCseed2)
      IF (RUNMCseed2.gt.1680000) NN2=INT(0.00001*RUNMCseed2)  
      IF (RUNMCseed2.gt.16800000) NN2=INT(0.000001*RUNMCseed2)
      IF (NN2.le.1)  NN2=34
      NN3=NN1+NN2 
      IF (NN3.gt.168) NN3=56

      write(6,*) ' RunMC : PHOJET will use such seeds', NN1,NN2,NN3,NN4


      INQUIRE(FILE="fitpar.dat", EXIST=EX0)
      IF (EX0) THEN
      write(6,*) " RunMC: file fitpar.dat was found"
      ELSE
      write(6,*) " RunMC: file fitpar.dat was not found!"
      write(6,*) " RunMC: copy it from $RUNMC/main/mcarlo/phojet/files" 
      ENDIF 

      inputsteer="phojet.cards" ! name of the steaering card
      INQUIRE(FILE=inputsteer, EXIST=EX)
      IF (EX) THEN
        ICARD=1
        WRITE(6,*) ''
        WRITE(6,*) 'RUNMC: File= ',inputsteer, ' exits!'
        WRITE(6,*) 'RUNMC: will try to overwrite some parameters:'
        open(12,FILE=inputsteer,STATUS='OLD',FORM='FORMATTED')
C initialise and run
        CALL PHOINP(12,IREJ,NN1,NN2,NN3,NN4) 
        IF (IREJ.ne.0) GOTO 4000
c open file for reading in main RunMC loop
        INQUIRE(FILE='phojet.tmp', EXIST=EX)
        IF (EX1) THEN
        close(2)
        open(UNIT=4,FILE='runmc.tmp',STATUS='old',FORM='unformatted')
        write(6,*) 'Open file phojet.tmp for reading'
        ENDIF 
      ELSE
        ICARD=0
        WRITE(6,*) ''
        WRITE(6,*) 'RUNMC: File= ',inputsteer, ' does not exits!'
        WRITE(6,*) 'RUNMC: use default parameters'
        WRITE(6,*) ''
        CALL PHOINP(-1,IREJ,NN1,NN2,NN3,NN4)
        IF (IREJ.ne.0) GOTO 4000 
C proton mass
         PRUM=0.93827 
         P1(1)=0D0
         P1(2)=0D0 
         P1(3)=1.0D0*ENER1
         P1(4)=1.0D0*ENER1

         P2(1)=0D0
         P2(2)=0D0
         P2(3)=-1.0D0*ENER2
         P2(4)=1.0D0*ENER2

** redefine by taking into acconu proton mass 
        IF (abs(PID1).eq.2212) P1(3)=SQRT(ENER1**2-PRUM**2) 
        IF (abs(PID2).eq.2212) P2(3)=SQRT(ENER2**2-PRUM**2) 
C  initialize phojet for given energy, particle combination
       CALL SETPAR(1,PID1,0,0.D0)
       CALL SETPAR(2,PID2,0,0.D0)
       CALL EVENT(-1,P1,P2,SIGMAX,IREJ)
       ENDIF ! end user initialisatin 


      write(6,*) ' FINISH INITIALIZATION'

      RETURN

 2000  CONTINUE  ! RUN 
************* Physical study *************** 

C...Call generate an event
       IF (ICARD.eq.0) THEN
          CALL EVENT(1,P1,P2,SIGCUR,IREJ)
          IF(IREJ.NE.0) GOTO 9999 
C.. convert from JETSET common
          CALL LUHEPC(1)
          if (nev.le.5)  CALL LULIST(1)
       ENDIF

C if reading temporary file
      IF (ICARD.eq.1) THEN
      IOSTA=0
      read(UNIT=4, IOSTAT=IOSTA) NEVHEP,NHEP 
      IF (IOSTA.ne.0) GOTO 9999 
      DO I=1,NHEP
      read(UNIT=4) ISTHEP(I),IDHEP(I),JMOHEP(1,I),JMOHEP(2,I),
     + JDAHEP(1,I),JDAHEP(2,I),PHEP(1,I),PHEP(2,I),PHEP(3,I),
     + PHEP(4,I),PHEP(5,I),VHEP(1,I),VHEP(2,I),VHEP(3,I),VHEP(4,I)
      ENDDO
      ENDIF


          nev=nev+1
C to check  
C        write(6,*) ' ' 
C        write(6,*) 'Total number in HEPEVT=',NHEP 
C        do i=1,NHEP
C        write(6,*) i, IDHEP(i),PHEP(1,i),PHEP(2,i),PHEP(3,i) 
C        enddo 

 9999  Continue
* end of loop >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      RETURN


 3000   CONTINUE

C  statistics output
       IF (ICARD.eq.0) CALL EVENT(-2,P1,P2,SIGMAX,IREJ)
       IF (ICARD.eq.1) close(UNIT=4) 
       close(12)

      xCross=1E09*SIGGEN(1)
      eCross=0
      write(6,*) 'Cross section in pb',xCross
      write(6,*) 'RUNMC-phojet: ALL done!'

 4000 CONTINUE

      RETURN      
      END
