C corrected to be used inside RunMC 
C S.Chekanov 

      SUBROUTINE POLUHI(IMODE,WEIGHT)
C**********************************************************************
C
C     example histrograms using LUND /HEPEVT/
C
C     input:  IMODE      -1  initialization
C                        -2  output of results
C                         1  take event statistics
C             WEIGHT     weight of event (if necessary)
C                        for final output: corresponding cross section

      INTEGER IMODE
      DOUBLE PRECISION WEIGHT

C Jetset common 
      PARAMETER (NMXHEP=2000)
      DOUBLE PRECISION PHEP,VHEP
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)


      INTEGER NEV
      SAVE NEV  


      IF (IMODE.eq.-1) THEN
      NEV=0
      write(6,*) ' RunMC:  Open temporary file = runmc.tmp'
      open(UNIT=2,FILE="runmc.tmp",STATUS='unknown',FORM='unformatted')
      ENDIF


      IF (IMODE.eq.1) THEN
      NEV=NEV+1 
      IF (NEV.le.5) CALL LULIST(1) 
      IF (NEV.eq.5) 
     + write(6,*)"RunMC: Wait! PHOJET fills temporary file runmc.tmp.."
      CALL LUHEPC(1)
      write(UNIT=2) NEVHEP,NHEP
      DO I=1,NHEP
      write(UNIT=2) ISTHEP(I),IDHEP(I),JMOHEP(1,I),JMOHEP(2,I), 
     + JDAHEP(1,I),JDAHEP(2,I),PHEP(1,I),PHEP(2,I),PHEP(3,I),
     + PHEP(4,I),PHEP(5,I),VHEP(1,I),VHEP(2,I),VHEP(3,I),VHEP(4,I) 
      ENDDO
      ENDIF

      IF (IMODE.eq.-2) THEN
      write(6,*) ' RunMC : Close temporary file = runmc.tmp'
      close(UNIT=2) 
      ENDIF



      END
