C
C
      SUBROUTINE ADDHIS(IHIS)
C**********************************************************************
C
C     add stored data to histogram no IHIS
C
C     output: COMMON HISTOS
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           TINY   =  1.D-10)
C
      PARAMETER (NHIS=200, NDIM=51)
      COMMON /HISTOS/ XLIMIT(3,NHIS),ISWI(NHIS),ENTRY(NHIS),
     &                HIST(4,NHIS,NDIM),EVENT(NHIS),OVERF(NHIS),
     &                UNDERF(NHIS),IBINS(NHIS),
     &                IHMIN(NHIS),IHMAX(NHIS),IHISL
C
      IF((IHIS.GT.0).AND.(IHIS.LE.IHISL)) THEN
        DO 300 K=IHMIN(IHIS),IHMAX(IHIS)
          HIST(2,IHIS,K) = HIST(2,IHIS,K)+HIST(4,IHIS,K)
          HIST(4,IHIS,K) = ZERO
 300    CONTINUE
        EVENT(IHIS) = EVENT(IHIS)+ONE
        IHMIN(IHIS) = IBINS(IHIS)
        IHMAX(IHIS) = 0
      ELSE IF(IHIS.EQ.-1) THEN
        DO 100 I=1,IHISL
          DO 200 K=IHMIN(I),IHMAX(I)
            HIST(2,I,K) = HIST(2,I,K)+HIST(4,I,K)
            HIST(4,I,K) = ZERO
 200      CONTINUE
          EVENT(I) = EVENT(I)+ONE
          IHMIN(I) = IBINS(I)
          IHMAX(I) = 0
 100    CONTINUE
      ELSE
        WRITE(6,'(1X,A,I12)') 'ADDHIS:ERROR:INVALID HISTOGRAM',IHIS
        CALL POABRT
      ENDIF
      END
