#!/bin/bash
#
# correct project files 
# created by S.Chekanov 
# 
MYDIR=`pwd`

# ###################################
PROJNAME=$RUNMC"/archive"; 
cd $PROJNAME;

for filename in *.rmc
# Traverse list of files ending with 1st argument.
do

rm -rf ${PROJNAME}/"proj"
unzip ${filename}
echo "process ${filename}"
 
chmod -R 755 ${PROJNAME}/"proj"
NAME=${PROJNAME}"/proj/user-comment.xml"
 
sed 's/JRunMC/JRunMC\/ui/g' $NAME > new.txt 
mv -f new.txt $NAME 

zip -rq ${filename} proj  -x \*.o
done

rm -rf ${PROJNAME}/"proj"

cd $MYDIR
exit 0
